//
//  SoundSetDocument.h
//  MQEditor
//
//  Created by groumpf on 27/07/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "AbstractDocument.h"
#import "SoundContainer.h"
#import "Sound.h"
#import "Multi.h"

/*
	Un SoundSet regroupe les 16 sons plus le multi
	et éventuellement d'autres reglages.
	Le but est de recharger l'ensemble des sons utiles a un morceau
	d'un seul coup et de faciliter l'edition en mode multi. 
	Les sons sont dans le SoundSet et la sauvegarde du SoundSet contient
	effectivement les données et non des liens sur d'autres fichiers.
*/
@interface SoundSetDocument : AbstractDocument 
{
	SoundContainer* soundSet;
	Multi* multi;
	
	IBOutlet id nameMatrix;
	IBOutlet id sound1Name;
	IBOutlet id sound2Name;
	IBOutlet id sound3Name;
	IBOutlet id sound4Name;
	IBOutlet id sound5Name;
	IBOutlet id sound6Name;
	IBOutlet id sound7Name;
	IBOutlet id sound8Name;
	IBOutlet id sound9Name;
	IBOutlet id sound10Name;
	IBOutlet id sound11Name;
	IBOutlet id sound12Name;
	IBOutlet id sound13Name;
	IBOutlet id sound14Name;
	IBOutlet id sound15Name;
	IBOutlet id sound16Name;
	
	IBOutlet id multiName;
	
}

- (void)setSound:(AbstractSound*)aSound At:(int)aIndex;
- (AbstractSound*)getSoundAt:(int)aIndex;
- (Multi*)multi;
- (void)setMulti:(Multi*)aMulti;


// actions

// obtient le son 1..16 suivant le tag de sender
- (void)getSound:(id)sender;

// affiche le selecteur de fichier pour charger un son 1..16 suivant le tag de sender
- (void)loadSound:(id)sender;

// appellée par getSound
- (void)getSoundNumber:(int)aNumber;

// recupere tous les buffers d'edition des sons du multi
- (void)getAllSounds:(id)sender;

// envoie tous les sons du soundset dans les buffers d'edition du multi
- (void)sendAllSounds:(id)sender;

// ouvre une fenetre d'edition sur le son 1..16 suivant le tag de sender
- (void)editSound:(id)sender;

// recupere le buffer d'edition du multi
- (void)getMulti:(id)sender;

// envoi le multi du SoundSet dans le buffer d'edition
- (void)editMulti:(id)sender;

// met a jour le nom d'un patch dans le set
- (void)setSoundName:(int)aPart name:(NSString*)aName;

// met a jour le nom du multi
- (void)setMultiNameString:(NSString*)aName;

@end
